#include "GSFinder.h"
#include "CommandBandsPPC.h"
#include "ListView.h"
TCHAR g_szMainTipsStrings[][32] = {
	_T(""), _T(""), _T(""), IDS_UPFOLDER, IDS_REFRESH,
	IDS_FOLDERVIEW, IDS_CTRLKEY, IDS_SHOWTOOLBAR
};
//MOD START TODA
TCHAR g_szToolTipsStrings[][32] = {
	IDS_BACK, IDS_FRONT,
	IDS_DELETE, IDS_PROPERTY, IDS_CUT, IDS_COPY, IDS_PASTE,
	IDS_LISTSTYLE, IDS_GOTOFOLDER
};
//MOD END
TCHAR g_szAddrTipsStrings[] = IDS_GOTOFOLDER;
LPTSTR g_lpszMainTips[8];
LPTSTR g_lpszToolTips[9];

WNDPROC Org_CmbEditProc = NULL;
///////////////////////////////////////////////////////////////
LRESULT CALLBACK CmbEditProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) 
	{
		//ADD START TODA
		case WM_SETFOCUS:
			g_MainWnd.m_CmdBands.SetEnableItemSelected3();
			g_MainWnd.m_CmdBands.SetEnableEditPasteBef();
			break;
		case WM_KILLFOCUS:
			g_MainWnd.m_CmdBands.SetEnableEditPasteAft();
			break;
		//ADD END
		case WM_KEYDOWN:	//MOD TODA (WM_KEYUP->WM_KEYDOWN)
		{
			if (wParam == VK_RETURN) {
				g_MainWnd.m_ListView.OnViewUpdate();
				return 0;
			}
			break;
		}
		default:
			break;
	}
	return CallWindowProc(Org_CmbEditProc, hWnd, message, wParam, lParam);
}
///////////////////////////////////////////////////////////////
CCmdBands::CCmdBands()
{
	m_Settings.bShowToolBar = TRUE;
	m_Settings.bShowAddressBar = TRUE;
}

///////////////////////////////////////////////////////////////
CCmdBands::~CCmdBands()
{
}

///////////////////////////////////////////////////////////////
//R}hoh̍쐬
void CCmdBands::Init(HWND hwndParent)
{
	GetSettings();

//MOD START GORIPON
	//CreateMenuBar(hwndParent);
	CreateMenuBar(hwndParent, g_MainWnd.m_bNumberShortcut, g_MainWnd.m_bSwapMenu);
//MOD END
	CreateToolBar(hwndParent);
	CreateAddressBar(hwndParent);

	ShowWindow(m_hAddressbar, m_Settings.bShowAddressBar?SW_SHOW:SW_HIDE);
	ShowWindow(m_hToolbar, m_Settings.bShowToolBar?SW_SHOW:SW_HIDE);
	
	SetCheckViewToolBar();
	SetCheckViewAddressBar();

	GetRecent();
}

///////////////////////////////////////////////////////////////
void CCmdBands::Destroy()
{
	SaveSettings();
	SaveRecent();
	DestroyWindow(m_hWnd);
}

///////////////////////////////////////////////////////////////
void CCmdBands::SetFolderName(LPCTSTR lpszPath)
{
	TCHAR szPath[MAX_PATH];
	wcscpy(szPath, GetRootName());
	if (wcslen(lpszPath))
		wcscpy(szPath, lpszPath);

	int nIndex = SendMessage(m_hComboBox, CB_FINDSTRINGEXACT, 0, (LPARAM)szPath);
	if (nIndex != CB_ERR)
		SendMessage(m_hComboBox, CB_DELETESTRING, nIndex, 0);

	SendMessage(m_hComboBox, CB_INSERTSTRING, 0, (LPARAM)szPath);
	SendMessage(m_hComboBox, CB_SETCURSEL, 0, 0);
}

///////////////////////////////////////////////////////////////
void CCmdBands::SetCheckListStyle(DWORD dwStyle, DWORD dwExStyle)
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT); //mod by kawa
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	CheckMenuItem(hMenu, ID_VIEW_LARGEICON, (dwStyle == LVS_ICON)?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_VIEW_SMALLICON, (dwStyle == LVS_SMALLICON)?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_VIEW_LIST, (dwStyle == LVS_LIST)?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	//MOD START TODA
	CheckMenuItem(hMenu, ID_VIEW_REPORT, (dwStyle == LVS_REPORT && !dwExStyle)?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_VIEW_REPORTLINE, (dwStyle == LVS_REPORT && dwExStyle)?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	//MOD END
}

///////////////////////////////////////////////////////////////
void CCmdBands::SetCheckSort(int nSort, BOOL bRaise)
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT); //mod by kawa
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	CheckMenuItem(hMenu, ID_VIEW_SORT_NAME, (nSort == LIST_SORT_NAME)?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_VIEW_SORT_EXT, (nSort == LIST_SORT_EXT)?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_VIEW_SORT_SIZE, (nSort == LIST_SORT_SIZE)?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_VIEW_SORT_TIME, (nSort == LIST_SORT_TIME)?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	CheckMenuItem(hMenu, ID_VIEW_SORT_NOT_RAISE, bRaise?MF_BYCOMMAND|MF_UNCHECKED:MF_BYCOMMAND|MF_CHECKED);
}

///////////////////////////////////////////////////////////////
void CCmdBands::SetCheckKeyOn(BOOL bCtrlOn, BOOL bShiftOn)
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);//mod by kawa
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	//Rg[
	SendMessage(m_hWnd, TB_SETSTATE, ID_EDIT_CONTROL_ON, bCtrlOn?TBSTATE_CHECKED|TBSTATE_ENABLED:TBSTATE_ENABLED);
	CheckMenuItem(hMenu, ID_EDIT_CONTROL_ON, bCtrlOn?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	//Vtg
	CheckMenuItem(hMenu, ID_EDIT_SHIFT_ON, bShiftOn?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
}

///////////////////////////////////////////////////////////////
void CCmdBands::SetCheckViewStatusWnd(BOOL bShowStatusWnd)
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);//mod by kawa
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	CheckMenuItem(hMenu, ID_VIEW_STATUSBAR, bShowStatusWnd?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
}
//ADD START TODA
///////////////////////////////////////////////////////////////
void CCmdBands::SetCheckViewFolder(BOOL bShowFolder)
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);//mod by kawa
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	CheckMenuItem(hMenu, ID_VIEW_FOLDER, bShowFolder?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	SendMessage(m_hWnd, TB_SETSTATE, ID_VIEW_FOLDER, bShowFolder?TBSTATE_CHECKED|TBSTATE_ENABLED:TBSTATE_ENABLED);
//ADD START GORIPON
	EnableMenuItem(hMenu, ID_VIEW_SIDE, bShowFolder?MF_BYCOMMAND|MF_ENABLED:MF_BYCOMMAND|MF_GRAYED);
	SetEnableFocusMove(bShowFolder);
//ADD END
}
///////////////////////////////////////////////////////////////
void CCmdBands::SetCheckViewSide(BOOL bViewSide)
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);//mod by kawa
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	CheckMenuItem(hMenu, ID_VIEW_SIDE, bViewSide?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
}
///////////////////////////////////////////////////////////////
void CCmdBands::SetCheckDragDrop(BOOL bDragDrop)
{
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);//mod by kawa
	CheckMenuItem(hMenu, ID_EDIT_DRAGDROP, bDragDrop?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
}
//ADD END
//ADD START GORIPON
///////////////////////////////////////////////////////////////
void CCmdBands::SetCheckViewHires(BOOL bHiRes)
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);
	CheckMenuItem(hMenu, ID_VIEW_HIRES, bHiRes?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	SetEnableViewHires(g_MainWnd.m_bHighDpiHardware);
}
//ADD END
///////////////////////////////////////////////////////////////
void CCmdBands::SetCheckViewToolBar()
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);//mod by kawa
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	CheckMenuItem(hMenu, ID_VIEW_TOOLBAR, m_Settings.bShowToolBar?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
	SendMessage(m_hWnd, TB_SETSTATE, ID_VIEW_TOOLBAR, m_Settings.bShowToolBar?TBSTATE_CHECKED|TBSTATE_ENABLED:TBSTATE_ENABLED);
}
///////////////////////////////////////////////////////////////
void CCmdBands::SetCheckViewAddressBar()
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);//mod by kawa
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	CheckMenuItem(hMenu, ID_VIEW_ADDRESSBAR, m_Settings.bShowAddressBar?MF_BYCOMMAND|MF_CHECKED:MF_BYCOMMAND|MF_UNCHECKED);
}

///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableUpperFolder(BOOL bEnable)
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);//mod by kawa
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	EnableMenuItem(hMenu, ID_VIEW_UPFOLDER, bEnable?MF_BYCOMMAND|MF_ENABLED:MF_BYCOMMAND|MF_GRAYED);
	SendMessage(m_hWnd, TB_SETSTATE, ID_VIEW_UPFOLDER, bEnable?TBSTATE_ENABLED:TBSTATE_INDETERMINATE);
	SendMessage(m_hToolbar, TB_SETSTATE, ID_VIEW_UPFOLDER, bEnable?TBSTATE_ENABLED:TBSTATE_INDETERMINATE);	//ADD GORIPON
}
//ADD START TODA
///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableFront(BOOL bEnable)
{
//MOD START GORIPON
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);
//MOD END
	EnableMenuItem(hMenu, ID_GO_FRONT, bEnable?MF_BYCOMMAND|MF_ENABLED:MF_BYCOMMAND|MF_GRAYED);
	SendMessage(m_hToolbar, TB_SETSTATE, ID_GO_FRONT, bEnable?TBSTATE_ENABLED:TBSTATE_INDETERMINATE);
}
///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableBack(BOOL bEnable)
{
//MOD START GORIPON
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);
//MOD END
	EnableMenuItem(hMenu, ID_GO_BACK, bEnable?MF_BYCOMMAND|MF_ENABLED:MF_BYCOMMAND|MF_GRAYED);
	SendMessage(m_hToolbar, TB_SETSTATE, ID_GO_BACK, bEnable?TBSTATE_ENABLED:TBSTATE_INDETERMINATE);
}
///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableCompressSelected(HMENU hMenu, HMENU hMenu2, int nPos, int nPos2, DWORD nCompDLL)
{
	HMENU hSubMenu = hMenu2;
	HMENU hSubMenu2 = hMenu2;
	if(nPos != -1)
		hSubMenu = GetSubMenu(hMenu2, nPos);
	if(nPos2 != -1)
		hSubMenu2 = GetSubMenu(hMenu2, nPos2);

	if(g_MainWnd.m_Compress.IsCompress(nCompDLL)) {
		EnableMenuItem(hMenu, ID_FILE_COMPRESS, MF_BYCOMMAND|MF_ENABLED);
		EnableMenuItem(hSubMenu2, ID_FILE_COMPRESS, MF_BYCOMMAND|MF_ENABLED);
	} else {
		EnableMenuItem(hMenu, ID_FILE_COMPRESS, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hSubMenu2, ID_FILE_COMPRESS, MF_BYCOMMAND|MF_GRAYED);
	}

	if(g_MainWnd.m_Compress.IsUnCompress()) {
		EnableMenuItem(hMenu, ID_FILE_UNCOMPRESS, MF_BYCOMMAND|MF_ENABLED);
		EnableMenuItem(hSubMenu, ID_FILE_UNCOMPRESS, MF_BYCOMMAND|MF_ENABLED);
	} else {
		EnableMenuItem(hMenu, ID_FILE_UNCOMPRESS, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hSubMenu, ID_FILE_UNCOMPRESS, MF_BYCOMMAND|MF_GRAYED);
	}
}
///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableSearchSelected(HMENU hMenu, LPTSTR lpszPath)
{
	if(wcscmp(IDS_SEARCH_FOLDER_NAME, lpszPath)==0)
	{
		EnableMenuItem(hMenu, ID_FILE_CREATE_SHORTCUT, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_CREATEFOLDER, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_EDIT_PASTE_SHORTCUT, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_CREATEFOLDER, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_COMPRESS, MF_BYCOMMAND|MF_GRAYED);
	}
}
///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableItemSelected()
{
	//ADD START TODA
	HWND hFocus = GetFocus();
	if(hFocus != g_MainWnd.m_ListView.m_hWnd)
		hFocus = NULL;
	//ADD END

	//MOD START TODA (from GSFinder ver.1.99)
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_FILE);//mod by kawa
	HMENU hMenu2 = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);//add by kawa
	if (hFocus && g_MainWnd.m_ListView.GetValidAndSelectedCount())	//MOD TODA
	{
		//j[L
		EnableMenuItem(hMenu, ID_FILE_OPEN, MF_BYCOMMAND|MF_ENABLED);
		EnableMenuItem(hMenu, ID_FILE_OPEN_PARAM, MF_BYCOMMAND|MF_ENABLED);//add by kawa
		EnableMenuItem(hMenu, ID_FILE_CREATE_SHORTCUT, MF_BYCOMMAND|MF_ENABLED);
		EnableMenuItem(hMenu, ID_FILE_DELETE, MF_BYCOMMAND|MF_ENABLED);
		EnableMenuItem(hMenu, ID_FILE_RENAME, MF_BYCOMMAND|MF_ENABLED);
		EnableMenuItem(hMenu, ID_FILE_PROPERTY, MF_BYCOMMAND|MF_ENABLED);
		//EnableMenuItem(hMenu, ID_EDIT_CUT, MF_BYCOMMAND|MF_ENABLED);
		//EnableMenuItem(hMenu, ID_EDIT_COPY, MF_BYCOMMAND|MF_ENABLED);
		//EnableMenuItem(hMenu, ID_EDIT_COPY_FILE_NAME, MF_BYCOMMAND|MF_ENABLED);
		//EnableMenuItem(hMenu, ID_EDIT_COPY_FILE_PATH, MF_BYCOMMAND|MF_ENABLED);
		EnableMenuItem(hMenu2, ID_EDIT_CUT, MF_BYCOMMAND|MF_ENABLED); //mod by kawa
		EnableMenuItem(hMenu2, ID_EDIT_COPY, MF_BYCOMMAND|MF_ENABLED); //mod by kawa
		EnableMenuItem(hMenu2, ID_EDIT_COPY_FILE_NAME, MF_BYCOMMAND|MF_ENABLED); //mod by kawa
		EnableMenuItem(hMenu2, ID_EDIT_COPY_FILE_PATH, MF_BYCOMMAND|MF_ENABLED); //mod by kawa
		EnableMenuItem(hMenu, ID_FILE_COPY_FOLDER, MF_BYCOMMAND|MF_ENABLED);
		EnableMenuItem(hMenu, ID_FILE_MOVE_FOLDER, MF_BYCOMMAND|MF_ENABLED);
		EnableMenuItem(hMenu, ID_FILE_SHORTCUT_FOLDER, MF_BYCOMMAND|MF_ENABLED);
		//ADD START TODA (kj[)
		//SetEnableCompressSelected(GetSubMenu(hMenu, 0), 0, 8, g_MainWnd.m_ListView.m_Settings.nCompDLL);
		SetEnableCompressSelected(hMenu,GetSubMenu(hMenu, 0), 0, 8, g_MainWnd.m_ListView.m_Settings.nCompDLL);
		//ADD END

		//c[o[L
		SendMessage(m_hToolbar, TB_SETSTATE, ID_FILE_DELETE, TBSTATE_ENABLED);
		SendMessage(m_hToolbar, TB_SETSTATE, ID_FILE_PROPERTY, TBSTATE_ENABLED);
		SendMessage(m_hToolbar, TB_SETSTATE, ID_EDIT_CUT, TBSTATE_ENABLED);
		SendMessage(m_hToolbar, TB_SETSTATE, ID_EDIT_COPY, TBSTATE_ENABLED);

		if (g_MainWnd.m_ListView.IsSelectionFile())
		{
			EnableMenuItem(hMenu, ID_FILE_IR_SEND, MF_BYCOMMAND|MF_ENABLED);
			EnableMenuItem(hMenu, ID_FILE_TO_APP, MF_BYCOMMAND|MF_ENABLED);
			EnableMenuItem(hMenu, ID_FILE_MAIL_SEND, MF_BYCOMMAND|MF_ENABLED);	//ADD GORIPON

			for (int i=0; i<g_MainWnd.m_ListView.m_nOpenAppInfoCount; i++)
				EnableMenuItem(hMenu, ID_FILE_OPEN_APP + i, MF_BYCOMMAND|MF_ENABLED);
		}
		else
		{
			EnableMenuItem(hMenu, ID_FILE_IR_SEND, MF_BYCOMMAND|MF_GRAYED);
			EnableMenuItem(hMenu, ID_FILE_TO_APP, MF_BYCOMMAND|MF_GRAYED);
			EnableMenuItem(hMenu, ID_FILE_MAIL_SEND, MF_BYCOMMAND|MF_GRAYED);	//ADD GORIPON

			for (int i=0; i<g_MainWnd.m_ListView.m_nOpenAppInfoCount; i++)
				EnableMenuItem(hMenu, ID_FILE_OPEN_APP + i, MF_BYCOMMAND|MF_GRAYED);
		}
	}
	else if (hFocus && ListView_GetSelectedCount(g_MainWnd.m_ListView.m_hWnd))	//MOD TODA
	{
		//j[𖳌
		EnableMenuItem(hMenu, ID_FILE_OPEN, MF_BYCOMMAND|MF_ENABLED);
		EnableMenuItem(hMenu, ID_FILE_OPEN_PARAM, MF_BYCOMMAND|MF_ENABLED);//add by kawa
		EnableMenuItem(hMenu, ID_FILE_CREATE_SHORTCUT, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_DELETE, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_RENAME, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_PROPERTY, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_IR_SEND, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_COPY_FOLDER, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_MOVE_FOLDER, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_SHORTCUT_FOLDER, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_TO_APP, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_MAIL_SEND, MF_BYCOMMAND|MF_GRAYED);	//ADD GORIPON
		EnableMenuItem(hMenu2, ID_EDIT_CUT, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu2, ID_EDIT_COPY, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu2, ID_EDIT_COPY_FILE_NAME, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu2, ID_EDIT_COPY_FILE_PATH, MF_BYCOMMAND|MF_GRAYED);
		//ADD START TODA
		EnableMenuItem(hMenu, ID_FILE_COMPRESS, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_UNCOMPRESS, MF_BYCOMMAND|MF_GRAYED);
		//ADD END

		for (int i=0; i<g_MainWnd.m_ListView.m_nOpenAppInfoCount; i++)
			EnableMenuItem(hMenu, ID_FILE_OPEN_APP + i, MF_BYCOMMAND|MF_GRAYED);

		//c[o[𖳌
		SendMessage(m_hToolbar, TB_SETSTATE, ID_FILE_DELETE, TBSTATE_INDETERMINATE);
		SendMessage(m_hToolbar, TB_SETSTATE, ID_FILE_PROPERTY, TBSTATE_INDETERMINATE);
		SendMessage(m_hToolbar, TB_SETSTATE, ID_EDIT_CUT, TBSTATE_INDETERMINATE);
		SendMessage(m_hToolbar, TB_SETSTATE, ID_EDIT_COPY, TBSTATE_INDETERMINATE);
	}
	else
	{
		//j[𖳌
		EnableMenuItem(hMenu, ID_FILE_OPEN, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_OPEN_PARAM, MF_BYCOMMAND|MF_GRAYED);//add by kawa
		EnableMenuItem(hMenu, ID_FILE_CREATE_SHORTCUT, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_DELETE, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_RENAME, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_PROPERTY, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_IR_SEND, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_COPY_FOLDER, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_MOVE_FOLDER, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_SHORTCUT_FOLDER, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_TO_APP, MF_BYCOMMAND|MF_GRAYED);
		//EnableMenuItem(hMenu, ID_EDIT_CUT, MF_BYCOMMAND|MF_GRAYED);
		//EnableMenuItem(hMenu, ID_EDIT_COPY, MF_BYCOMMAND|MF_GRAYED);
		//EnableMenuItem(hMenu, ID_EDIT_COPY_FILE_NAME, MF_BYCOMMAND|MF_GRAYED);
		//EnableMenuItem(hMenu, ID_EDIT_COPY_FILE_PATH, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_MAIL_SEND, MF_BYCOMMAND|MF_GRAYED);	//ADD GORIPON
		EnableMenuItem(hMenu2, ID_EDIT_CUT, MF_BYCOMMAND|MF_GRAYED); //mod by kawa
		EnableMenuItem(hMenu2, ID_EDIT_COPY, MF_BYCOMMAND|MF_GRAYED); //mod by kawa
		EnableMenuItem(hMenu2, ID_EDIT_COPY_FILE_NAME, MF_BYCOMMAND|MF_GRAYED); //mod by kawa
		EnableMenuItem(hMenu2, ID_EDIT_COPY_FILE_PATH, MF_BYCOMMAND|MF_GRAYED); //mod by kawa
		//ADD START TODA
		EnableMenuItem(hMenu, ID_FILE_COMPRESS, MF_BYCOMMAND|MF_GRAYED);
		EnableMenuItem(hMenu, ID_FILE_UNCOMPRESS, MF_BYCOMMAND|MF_GRAYED);
		//ADD END

		for (int i=0; i<g_MainWnd.m_ListView.m_nOpenAppInfoCount; i++)
			EnableMenuItem(hMenu, ID_FILE_OPEN_APP + i, MF_BYCOMMAND|MF_GRAYED);

		//c[o[𖳌
		SendMessage(m_hToolbar, TB_SETSTATE, ID_FILE_DELETE, TBSTATE_INDETERMINATE);
		SendMessage(m_hToolbar, TB_SETSTATE, ID_FILE_PROPERTY, TBSTATE_INDETERMINATE);
		SendMessage(m_hToolbar, TB_SETSTATE, ID_EDIT_CUT, TBSTATE_INDETERMINATE);
		SendMessage(m_hToolbar, TB_SETSTATE, ID_EDIT_COPY, TBSTATE_INDETERMINATE);
	}
	//MOD END
	//ADD START TODA (̗L/)
	SetEnableSearchSelected(hMenu, g_MainWnd.m_ListView.m_szCurrentFolder);
	//ADD END
}
//ADD START TODA (c[r[pj[ݒ)
///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableItemSelected2()
{
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_FILE); //mod by kawa
	HMENU hMenu2 = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT); //add by kawa

	//j[L
	EnableMenuItem(hMenu, ID_FILE_OPEN, MF_BYCOMMAND|MF_ENABLED);
	EnableMenuItem(hMenu, ID_FILE_CREATE_SHORTCUT, MF_BYCOMMAND|MF_ENABLED);
	EnableMenuItem(hMenu, ID_FILE_DELETE, MF_BYCOMMAND|MF_ENABLED);
	EnableMenuItem(hMenu, ID_FILE_RENAME, MF_BYCOMMAND|MF_ENABLED);
	EnableMenuItem(hMenu, ID_FILE_PROPERTY, MF_BYCOMMAND|MF_ENABLED);
	//EnableMenuItem(hMenu, ID_EDIT_CUT, MF_BYCOMMAND|MF_ENABLED);
	//EnableMenuItem(hMenu, ID_EDIT_COPY, MF_BYCOMMAND|MF_ENABLED);
	//EnableMenuItem(hMenu, ID_EDIT_COPY_FILE_NAME, MF_BYCOMMAND|MF_ENABLED);
	//EnableMenuItem(hMenu, ID_EDIT_COPY_FILE_PATH, MF_BYCOMMAND|MF_ENABLED);
	EnableMenuItem(hMenu2, ID_EDIT_CUT, MF_BYCOMMAND|MF_ENABLED);//mod by kawa
	EnableMenuItem(hMenu2, ID_EDIT_COPY, MF_BYCOMMAND|MF_ENABLED);//mod by kawa
	EnableMenuItem(hMenu2, ID_EDIT_COPY_FILE_NAME, MF_BYCOMMAND|MF_ENABLED); //mod by kawa
	EnableMenuItem(hMenu2, ID_EDIT_COPY_FILE_PATH, MF_BYCOMMAND|MF_ENABLED); //mod by kawa
	EnableMenuItem(hMenu, ID_FILE_COPY_FOLDER, MF_BYCOMMAND|MF_ENABLED);
	EnableMenuItem(hMenu, ID_FILE_MOVE_FOLDER, MF_BYCOMMAND|MF_ENABLED);
	EnableMenuItem(hMenu, ID_FILE_SHORTCUT_FOLDER, MF_BYCOMMAND|MF_ENABLED);
	//SetEnableCompressSelected(GetSubMenu(hMenu, 0), 0, 8, g_MainWnd.m_ListView.m_Settings.nCompDLL);
	SetEnableCompressSelected(hMenu, GetSubMenu(hMenu, 0), 0, 8, g_MainWnd.m_ListView.m_Settings.nCompDLL);//mod by kawa

	//c[o[L
	SendMessage(m_hToolbar, TB_SETSTATE, ID_FILE_DELETE, TBSTATE_ENABLED);
	SendMessage(m_hToolbar, TB_SETSTATE, ID_FILE_PROPERTY, TBSTATE_ENABLED);
	SendMessage(m_hToolbar, TB_SETSTATE, ID_EDIT_CUT, TBSTATE_ENABLED);
	SendMessage(m_hToolbar, TB_SETSTATE, ID_EDIT_COPY, TBSTATE_ENABLED);

	EnableMenuItem(hMenu, ID_FILE_IR_SEND, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_TO_APP, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_MAIL_SEND, MF_BYCOMMAND|MF_GRAYED);	//ADD GORIPON

	for (int i=0; i<g_MainWnd.m_ListView.m_nOpenAppInfoCount; i++)
		EnableMenuItem(hMenu, ID_FILE_OPEN_APP + i, MF_BYCOMMAND|MF_GRAYED);
}

///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableItemSelected3()
{
	//HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETMENU, 0, 0);
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_FILE); // mod by kawa
	HMENU hMenu2 = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT); // add by kawa

	//j[L
	EnableMenuItem(hMenu, ID_EDIT_CUT, MF_BYCOMMAND|MF_ENABLED);
	EnableMenuItem(hMenu, ID_EDIT_COPY, MF_BYCOMMAND|MF_ENABLED);

	//j[𖳌
	EnableMenuItem(hMenu, ID_FILE_OPEN, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_CREATE_SHORTCUT, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_DELETE, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_RENAME, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_PROPERTY, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_IR_SEND, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_COPY_FOLDER, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_MOVE_FOLDER, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_SHORTCUT_FOLDER, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_TO_APP, MF_BYCOMMAND|MF_GRAYED);
	//EnableMenuItem(hMenu, ID_EDIT_COPY_FILE_NAME, MF_BYCOMMAND|MF_GRAYED);
	//EnableMenuItem(hMenu, ID_EDIT_COPY_FILE_PATH, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_MAIL_SEND, MF_BYCOMMAND|MF_GRAYED);	//ADD GORIPON
	EnableMenuItem(hMenu2, ID_EDIT_COPY_FILE_NAME, MF_BYCOMMAND|MF_GRAYED);//mod by kawa
	EnableMenuItem(hMenu2, ID_EDIT_COPY_FILE_PATH, MF_BYCOMMAND|MF_GRAYED);// mod by kawa
	EnableMenuItem(hMenu, ID_FILE_COMPRESS, MF_BYCOMMAND|MF_GRAYED);
	EnableMenuItem(hMenu, ID_FILE_UNCOMPRESS, MF_BYCOMMAND|MF_GRAYED);

	for (int i=0; i<g_MainWnd.m_ListView.m_nOpenAppInfoCount; i++)
		EnableMenuItem(hMenu, ID_FILE_OPEN_APP + i, MF_BYCOMMAND|MF_GRAYED);

	//c[o[L
	SendMessage(m_hToolbar, TB_SETSTATE, ID_EDIT_CUT, TBSTATE_ENABLED);
	SendMessage(m_hToolbar, TB_SETSTATE, ID_EDIT_COPY, TBSTATE_ENABLED);

	//c[o[𖳌
	SendMessage(m_hToolbar, TB_SETSTATE, ID_FILE_DELETE, TBSTATE_INDETERMINATE);
	SendMessage(m_hToolbar, TB_SETSTATE, ID_FILE_PROPERTY, TBSTATE_INDETERMINATE);
}
//ADD END
//ADD START GORIPON
///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableViewHires(BOOL bHiRes)
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);
	EnableMenuItem(hMenu, ID_VIEW_HIRES, bHiRes?MF_BYCOMMAND|MF_ENABLED:MF_BYCOMMAND|MF_GRAYED);
}
///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableFocusMove(BOOL bShowFolder)
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);
	EnableMenuItem(hMenu, ID_FOCUS_MOVE, bShowFolder?MF_BYCOMMAND|MF_ENABLED:MF_BYCOMMAND|MF_GRAYED);
}
///////////////////////////////////////////////////////////////
void CCmdBands::SetModeFocusMove(BOOL bFocus)
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);
	MENUITEMINFO mii;
	memset(&mii, 0, sizeof(MENUITEMINFO));
	mii.cbSize = sizeof(MENUITEMINFO);
	mii.fMask = MIIM_TYPE;
	mii.fType = MFT_STRING;
	TCHAR *lpszItemName = new TCHAR[1024];
	wsprintf(lpszItemName, IDS_FOCUS_MOVE, bFocus?IDS_FILE:IDS_FOLDER, g_MainWnd.m_bNumberShortcut?_T('9'):_T('M'));
	mii.dwTypeData = lpszItemName;
	SetMenuItemInfo(hMenu, ID_FOCUS_MOVE, FALSE, &mii);
	delete lpszItemName;
	m_bFocuaMoveList = bFocus;
}
//ADD END
///////////////////////////////////////////////////////////////
void CCmdBands::SaveSettings()
{
	HKEY hKey = 0;
	DWORD dwDisposition;

	//L[ݒ
	if (RegCreateKeyEx(HKEY_CURRENT_USER, REG_KEY_REBAR,
		0, _T(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition)==ERROR_SUCCESS)
	{
		RegSetValueEx(hKey, _T("CmdBands"), 0, REG_BINARY, (LPBYTE)&m_Settings, sizeof(m_Settings));

		RegCloseKey(hKey);
	}
}
///////////////////////////////////////////////////////////////
void CCmdBands::GetSettings()
{
	HKEY hKey = 0;
	DWORD dwDisposition;

	//L[擾
	if (RegCreateKeyEx(HKEY_CURRENT_USER, REG_KEY_REBAR,
		0, _T(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition)==ERROR_SUCCESS)
	{
		DWORD dwType;
		BYTE* lpData;
		DWORD dwDataSize;

		//m_Settings
		dwType = REG_BINARY;
		lpData = new BYTE[sizeof(m_Settings)];
		dwDataSize = sizeof(m_Settings);
		if (RegQueryValueEx(hKey, _T("CmdBands"), 0, &dwType, lpData, &dwDataSize) == ERROR_SUCCESS)
			memcpy(&m_Settings, lpData, sizeof(m_Settings));

		delete[] lpData;

		RegCloseKey(hKey);
	}
}

///////////////////////////////////////////////////////////////
//MOD START GORIPON
//void CCmdBands::CreateMenuBar(HWND hwndParent)
void CCmdBands::CreateMenuBar(HWND hwndParent, BOOL bNumShortcut, BOOL bSwapMenu)
//MOD END
{
    SHMENUBARINFO mbi;
	memset(&mbi, 0, sizeof(SHMENUBARINFO));
	mbi.cbSize = sizeof(SHMENUBARINFO);
//MOD START GORIPON
	//mbi.hwndParent = g_MainWnd.m_hWnd;
	//mbi.nToolBarId = IDR_MAINFRAME; //menu
	mbi.hwndParent = hwndParent;
	mbi.nToolBarId = bNumShortcut? (bSwapMenu? IDR_MAINFRAME1_SWAP:IDR_MAINFRAME1):(bSwapMenu? IDR_MAINFRAME_SWAP:IDR_MAINFRAME);
//MOD END
	mbi.hInstRes = g_hInst;
	mbi.nBmpId = 0;
	mbi.cBmpImages = 0;

	if (!SHCreateMenuBar(&mbi))
	{
		MessageBox(g_MainWnd.m_hWnd, L"SHCreateMenuBar Failed", L"Error", MB_OK);
	}
	m_hWnd = mbi.hwndMB;
}
//ADD START GORIPON
///////////////////////////////////////////////////////////////
void CCmdBands::SetTypeMenuBar(BOOL bNumShortcut, BOOL bSwapMenu)
{
	HWND hwp = GetParent(m_hWnd);
	CloseHandle(m_hWnd);
	CreateMenuBar(hwp, bNumShortcut, bSwapMenu);
	//ʂ̃[NNĂ邪Q͂قƂǂȂƎv̂ō̂Ƃۗ()
}
//ADD END

///////////////////////////////////////////////////////////////
void CCmdBands::CreateToolBar(HWND hwndParent)
{
	m_hToolbar= CommandBar_Create(g_hInst, hwndParent, 0);
	int nNum = 9;
	for (int i=0; i<nNum; i++)
		g_lpszToolTips[i] = g_szToolTipsStrings[i];
		
	CommandBar_AddBitmap(m_hToolbar, g_hInst, IDR_TOOLBAR, nNum, 0, 0);
	CommandBar_AddToolTips(m_hToolbar, nNum, g_lpszToolTips);

	//iBitmap, idCommand, fsState, fsStyle, dwData, iString	
	TBBUTTON tbbMain[] = {
//MOD START GORIPON
//		{0, ID_GO_BACK, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
//		{1, ID_GO_FRONT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 1},
//		{0, NULL, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0},
//		{2, ID_FILE_DELETE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 2},				
//		{3, ID_FILE_PROPERTY, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 3},
//		{0, NULL, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0},
//		{4, ID_EDIT_CUT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 4},
//		{5, ID_EDIT_COPY, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 5},
//		{6, ID_EDIT_PASTE, TBSTATE_INDETERMINATE, TBSTYLE_BUTTON, 0, 6},
//		{0, NULL, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0},
//		{7, ID_VIEW_STYLE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 7},
//		{0, NULL, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0},
//		{8, IDC_BTN_GOTOFOLDER, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 8},		//ADD TODA
////	{0, ID_FILE_CREATEFOLDER, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},	//DEL TODA 
////	{7, ID_TOOL_MYDOCUMENTS, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 7},	//DEL TODA
////	{8, ID_TOOL_STARTMENU, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 8},		//DEL TODA
		{0, ID_GO_BACK, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0},
		{1, ID_GO_FRONT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 1},
		{2, ID_VIEW_UPFOLDER, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 2},
		{0, NULL, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0},
		{3, ID_FILE_DELETE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 3},				
		{4, ID_FILE_PROPERTY, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 4},
		{5, ID_EDIT_CUT, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 5},
		{6, ID_EDIT_COPY, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 6},
		{7, ID_EDIT_PASTE, TBSTATE_INDETERMINATE, TBSTYLE_BUTTON, 0, 7},
		{8, ID_VIEW_STYLE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 8},
		{9, IDC_BTN_GOTOFOLDER, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 9},
//MOD END
	};
	CommandBar_AddButtons(m_hToolbar, sizeof(tbbMain) / sizeof(TBBUTTON), tbbMain);

	SetWindowLong(m_hToolbar, GWL_STYLE, GetWindowLong(m_hToolbar, GWL_STYLE)|CCS_NOPARENTALIGN);
}
///////////////////////////////////////////////////////////////
void CCmdBands::CreateAddressBar(HWND hwndParent)
{
	m_hAddressbar= CommandBar_Create(g_hInst, hwndParent, 0);

	m_hComboBox = CommandBar_InsertComboBox(m_hAddressbar, g_hInst, GetSystemMetrics(SM_CXSCREEN) - 2, CBS_AUTOHSCROLL|CBS_DROPDOWN|WS_VSCROLL, 0, NULL);
	SendMessage(m_hComboBox, CB_SETEXTENDEDUI, TRUE, 0);

	HWND hwndEdit = GetWindow(m_hComboBox, GW_CHILD);
	Org_CmbEditProc = (WNDPROC)GetWindowLong(hwndEdit, GWL_WNDPROC);
	SetWindowLong(hwndEdit, GWL_WNDPROC, (DWORD)CmbEditProc);

	MoveWindow(m_hAddressbar, 0, 0, GetSystemMetrics(SM_CXSCREEN), 22, TRUE);
}
//ADD START TODA
///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableEditPasteBef()
{
	SetEnableEditPaste(FALSE);

	//Nbv{[hI[v
	if(OpenClipboard(NULL)) {

		//Nbv{[hɃf[^ꍇ͗L
		HANDLE hClipText = GetClipboardData(CF_UNICODETEXT);
		if(hClipText)
			SetEnableEditPaste(TRUE, FALSE);

		//Nbv{[hN[Y
		CloseClipboard();
	}
}
///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableEditPasteAft()
{
	//Rs[t@Cɂăj[̗L/ݒ
	SetEnableEditPaste((g_MainWnd.m_ListView.m_lpliinfo?TRUE:FALSE));
}
//ADD END
///////////////////////////////////////////////////////////////
void CCmdBands::SetEnableEditPaste(BOOL bEnable, BOOL bShortCut)	//MOD TODA
{
	HMENU hMenu = (HMENU)SendMessage(m_hWnd, SHCMBM_GETSUBMENU, 0, ID_EDIT);
	EnableMenuItem(hMenu, ID_EDIT_PASTE, bEnable?MF_BYCOMMAND|MF_ENABLED:MF_BYCOMMAND|MF_GRAYED);
	//MOD START TODA
	if(bShortCut)
		EnableMenuItem(hMenu, ID_EDIT_PASTE_SHORTCUT, bEnable?MF_BYCOMMAND|MF_ENABLED:MF_BYCOMMAND|MF_GRAYED);
	//MOD END
	SendMessage(m_hToolbar, TB_SETSTATE, ID_EDIT_PASTE, bEnable ? TBSTATE_ENABLED : TBSTATE_INDETERMINATE);
}
///////////////////////////////////////////////////////////////
void CCmdBands::SaveRecent()
{
	HKEY hKey = 0;
	DWORD dwDisposition;
	if (RegCreateKeyEx(HKEY_CURRENT_USER, REG_KEY_RECENT, 0, 
		_T(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition) == ERROR_SUCCESS)
	{
		TCHAR szName[32];
		TCHAR szData[MAX_PATH];
		for (int i = 0; i < 8; i++) {
			wsprintf(szName, _T("Recent%d"), i + 1);
			if (SendMessage(m_hComboBox, CB_GETLBTEXT, i, (LPARAM)szData) != CB_ERR)
				RegSetValueEx(hKey, szName, 0, REG_SZ, (LPBYTE)szData, (wcslen(szData) + 1) * sizeof(TCHAR));
		}
		RegCloseKey(hKey);
	}
}
///////////////////////////////////////////////////////////////
void CCmdBands::GetRecent()
{
	if (m_hComboBox)
	{
		HKEY hKey = 0;
		DWORD dwDisposition;
		if (RegCreateKeyEx(HKEY_CURRENT_USER, REG_KEY_RECENT, 0, 
			_T(""), REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition) == ERROR_SUCCESS)
		{
			DWORD dwDataSize;
			DWORD dwType = REG_SZ;
			BYTE bData[MAX_PATH * sizeof(TCHAR)];

			TCHAR szName[32];
			for (int i = 8 ; i > 0; i--)
			{
				dwDataSize = sizeof(bData);
				wsprintf(szName, _T("Recent%d"), i);
				if (RegQueryValueEx(hKey, szName, 0, &dwType, bData, &dwDataSize) == ERROR_SUCCESS)
				{
					if (wcslen((LPTSTR)bData))
						SendMessage(m_hComboBox, CB_INSERTSTRING, 0, (LPARAM)bData);
				}
			}
			RegCloseKey(hKey);
		}
	}
}
///////////////////////////////////////////////////////////////
void CCmdBands::OnViewToolBar()
{
	m_Settings.bShowToolBar = !m_Settings.bShowToolBar;
	ShowWindow(m_hToolbar, m_Settings.bShowToolBar?SW_SHOW:SW_HIDE);
	SetCheckViewToolBar();

	g_MainWnd.RecalcLayout();
}
///////////////////////////////////////////////////////////////
void CCmdBands::OnViewAddressBar()
{
	m_Settings.bShowAddressBar = !m_Settings.bShowAddressBar;
	ShowWindow(m_hAddressbar, m_Settings.bShowAddressBar?SW_SHOW:SW_HIDE);
	SetCheckViewAddressBar();

	g_MainWnd.RecalcLayout();
}
